src/Form/Type/RoleType.php
<?php

/*
 * This file is part of the DATAtourisme project.
 * 2022
 * @author Conjecto <contact@conjecto.com>
 * SPDX-License-Identifier: GPL-3.0-or-later
 * For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 */

namespace App\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\OptionsResolver\Options;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Security\Core\Role\Role;
use Symfony\Component\Security\Core\Role\RoleHierarchyInterface;
use Symfony\Component\Security\Core\Security;
use Symfony\Component\Security\Core\User\UserInterface;

class RoleType extends AbstractType
{
    /**
     * @var Security
     */
    private $security;

    /**
     * @var RoleHierarchyInterface
     */
    private $roleHierarchy;

    /**
     * UserVoter constructor.
     *
     * @param $roleHierarchy
     */
    public function __construct(Security $security, RoleHierarchyInterface $roleHierarchy)
    {
        $this->security = $security;
        $this->roleHierarchy = $roleHierarchy;
    }

    /**
     * @return mixed
     */
    public function getParent()
    {
        return ChoiceType::class;
    }

    /**
     * @param OptionsResolver $resolver
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $roles = [];

        // get user reachable roles
        $user = $this->security->getUser();
        if ($user instanceof UserInterface) {
            $roles = $this->roleHierarchy->getReachableRoleNames($user->getRoles());
            $roles = array_combine($roles, $roles);
            $roles = array_reverse($roles);
        }

        $resolver
            ->setDefaults([
                'label' => 'Rôle',
                'choices' => $roles,
            ]);

        $resolver->addAllowedTypes('choice_label', 'array');
        $resolver->setNormalizer('choice_label', function (Options $options, $labels) {
            if (is_array($labels)) {
                return function ($value, $key, $index) use ($labels) {
                    return isset($labels[$value]) ? $labels[$value] : $value;
                };
            }

            return $labels;
        });
    }
}

templates/components/footer.html.twig
{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

<!-- /.content-wrapper -->
<footer class="main-footer pb-3">
    <div class="container">
        <div class="row">
            <div class="col-xs-6 col-sm-3 col-lg-3">
                <h5>DATAtourisme</h5>
                <ul class="list-unstyled">
                    <li><a href="https://info.datatourisme.gouv.fr">{{ "menu.project_presentation" | trans }}</a></li>
                    <li><a href="https://producteur.datatourisme.gouv.fr">{{ "menu.webapp_producer" | trans }}</a></li>
                    <li><a href="https://diffuseur.datatourisme.gouv.fr">{{ "menu.webapp_consumer" | trans }}</a></li>
                    <li><a href="https://framagit.org/datatourisme" target="_blank">{{ "menu.developer_resources" | trans }}</a></li>
                    <li><a href="https://info.datatourisme.gouv.fr/2018/04/09/documentation-application-diffuseurs-datatourisme/" target="_blank">{{ "menu.documentation" | trans }}</a></li>
                    <li><a href="https://www.etalab.gouv.fr/wp-content/uploads/2017/04/ETALAB-Licence-Ouverte-v2.0.pdf" target="_blank">{{ "menu.license" | trans }}</a></li>
                    {#<li><a href="/fr/apidoc/">API</a></li>#}
                    <li><a href="https://www.datatourisme.gouv.fr/{{ app.request.locale }}/legal">{{ "menu.legal_notice" | trans }}</a></li>
                </ul>
            </div>
            <div class="col-xs-6 col-sm-5 col-lg-5">
                <div class="row">
                    <div class="col-xs-12 col-sm-6 col-lg-5">
                        <h5>{{ "menu.network" | trans }}</h5>
                        <ul class="list-unstyled">
                            <li><a href="http://www.data.gouv.fr" target="_blank">Data.gouv.fr</a></li>
                            <li><a href="http://www.gouvernement.fr" target="_blank">Gouvernement.fr</a></li>
                            <li><a href="http://www.france.fr" target="_blank">France.fr</a></li>
                            <li><a href="http://www.legifrance.gouv.fr" target="_blank">Legifrance.gouv.fr</a></li>
                            <li><a href="http://www.service-public.fr" target="_blank">Service-public.fr</a></li>
                        </ul>
                    </div>
                    <div class="col-xs-12 col-sm-6 col-lg-7">
                        <h5>{{ "menu.partners" | trans }}</h5>
                        <ul class="list-unstyled">
                            <li><a href="https://www.etalab.gouv.fr" target="_blank">Etalab</a></li>
                            <li><a href="http://atout-france.fr" target="_blank">Atout France</a></li>
                        </ul>
                    </div>
                </div>
            </div>
            <div class="clearfix visible-xs-block"></div>
            <div class="col-xs-12 col-sm-4">
                <div class="mt-8 text-right" style="line-height: 2em">{{ "credits.text" | trans | raw }}</div>
            </div>
        </div>

        {% if shivas_manager is defined %}
        <div class="row mt-3">
            <div class="col-xs-12">
                <div class="text-muted text-xs">version {{ shivas_manager.version }}</div>
            </div>
        </div>
        {% endif %}
    </div>
</footer>

templates/components/menu.html.twig
{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends '@KnpMenu/menu.html.twig' %}
{% import '@KnpMenu/menu.html.twig' as knp_menu %}

{% block list %}
    {% if item.hasChildren and options.depth is not same as(0) and item.displayChildren %}
        {%- set class = item.parent ? 'dropdown-menu' : 'nav navbar-nav' %}
        {%- set listAttributes = listAttributes|merge({'class': (listAttributes.class|default('') ~ ' ' ~ class)|trim }) %}
        {{ parent() }}
    {% endif %}
{% endblock %}

{% block item %}
    {% if item.displayed %}
        {# building the class of the item #}
        {%- set classes = item.attribute('class') is not empty ? [item.attribute('class')] : [] %}
        {%- if matcher.isCurrent(item) %}
            {%- set classes = classes|merge([options.currentClass]) %}
        {%- elseif matcher.isAncestor(item, options.matchingDepth) %}
            {%- set classes = classes|merge([options.ancestorClass]) %}
        {%- endif %}
        {%- if item.actsLikeFirst %}
            {%- set classes = classes|merge([options.firstClass]) %}
        {%- endif %}
        {%- if item.actsLikeLast %}
            {%- set classes = classes|merge([options.lastClass]) %}
        {%- endif %}

        {# Mark item as "leaf" (no children) or as "branch" (has children that are displayed) #}
        {% if item.hasChildren and options.depth is not same as(0) %}
            {% if options.branch_class is not empty and item.displayChildren %}
                {%- set classes = classes|merge([options.branch_class]) %}
            {% endif %}
        {% elseif options.leaf_class is not empty %}
            {%- set classes = classes|merge([options.leaf_class]) %}
        {%- endif %}

        {%- set attributes = item.attributes %}
        {%- if classes is not empty %}
            {%- set attributes = attributes|merge({'class': classes|join(' ')}) %}
        {%- endif %}

        {%- if item.displayChildren and item.children|length > 0 -%}
            {%- set attributes = attributes|merge({'class': (attributes.class|default('') ~ ' dropdown')|trim }) %}
        {%- endif -%}

        {# displaying the item #}
        {%- if item.extras.divider is defined and (item.extras.divider == 'prepend' or item.extras.divider == 'both') %}
            {{ block('dividerElement') }}
        {%- endif %}
        <li{{ knp_menu.attributes(attributes) }}>
            {%- if item.uri is not empty and (not matcher.isCurrent(item) or options.currentAsLink) %}
                {{ block('linkElement') }}
            {%- else %}
                {{ block('spanElement') }}
            {%- endif %}
            {# render the list of children#}
            {%- set childrenClasses = item.childrenAttribute('class') is not empty ? [item.childrenAttribute('class')] : [] %}
            {%- set childrenClasses = childrenClasses|merge(['menu_level_' ~ item.level]) %}
            {%- set listAttributes = item.childrenAttributes|merge({'class': childrenClasses|join(' ') }) %}
            {{ block('list') }}
        </li>
        {%- if item.extras.divider is defined and (item.extras.divider == 'append' or item.extras.divider == 'both') %}
            {{ block('dividerElement') }}
        {%- endif %}
    {% endif %}
{% endblock %}

{%- block linkElement -%}
    {%- set linkAttributes = item.linkAttributes -%}
    {%- set isDropdown = item.displayChildren and item.children|length > 0 -%}
    {%- if isDropdown -%}
        {%- set linkAttributes = linkAttributes|merge({'class': (linkAttributes.class|default('') ~ ' dropdown-toggle')|trim, 'data-toggle': 'dropdown' }) %}
    {%- endif -%}
    <a href="{{ item.uri }}"{{ knp_menu.attributes(linkAttributes) }}>
        {%- if item.extras.icon is defined -%}
            <i class="{{ item.extras.icon }}"></i> &nbsp;
        {%- endif -%}
        {{- block('label') -}}
        {%- if isDropdown -%}
            &nbsp;<span class="caret"></span>
        {%- endif -%}
    </a>
{%- endblock -%}

{% block dividerElement %}
    {% if item.level == 1 %}
        <li class="divider-vertical"></li>
    {% else %}
        <li class="divider"></li>
    {% endif %}
{% endblock %}